/*
	Copyright (c) 2010-2017 thomas.zink _at_ uni-konstanz _dot_ de
	
	Permission is hereby granted, free of charge, to any person
	obtaining a copy of this software and associated documentation
	files (the "Software"), to deal in the Software without
	restriction, including without limitation the rights to use,
	copy, modify, merge, publish, distribute, sublicense, and/or
	sell copies of the Software, and to permit persons to whom the
	Software is furnished to do so, subject to the following
	conditions:

	The above copyright notice and this permission notice shall be
	included in all copies or substantial portions of the Software.

	THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
	EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
	OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
	NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
	HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
	WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
	FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
	OTHER DEALINGS IN THE SOFTWARE.
*/
#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>

/*
	This is an example implementation of the hash functions provided by
	jdisy_hash in ansi c. It is used as a reference and for cross checking
	correctness. The output is actually used as parameter input for the 
	junit test suite.
	
	@author thomas zink
 */
int64_t BUZtab[256] = {
	0xbb1ad57319b89cd8L,0x68fb0e6f684df992L,0x352cccfc0946b8f0L,0x552cf1e4a8ab85ddL,
	0xf7bed9d4b5f30868L,0x190e5722719b812L,0xf6b55bba28da1b7eL,0xf09b04b38dd7aee4L,
	0xf27b5db0e9340cfcL,0xefe49da97cb1c23bL,0x65ad3780e9f97898L,0x58f6f13d28ca7a36L,
	0x4b4752645e76f39eL,0x81a8e923dd4d7273L,0x1db004fa8a0cebccL,0xc541d6e99556ad8dL,
	0xa8eeba810ad4107cL,0x28209046c2fd1ce6L,0x60d1d9429fbcaa08L,0x23c77cb6e11760a5L,
	0xb1e81c4f73418369L,0xce23684a013e0402L,0x149546ada2d4a21L,0x85ec2fb805feb9c0L,
	0xbe75c448b47b885bL,0x245b99b846685cfbL,0x7b528bf8134c9d4fL,0x8b67f1909c4fba23L,
	0x93bcd79bf47657ebL,0x347536f046296448L,0x9f94c56130b117afL,0x2f48f6fc00551a97L,
	0x2bc36abaefb97d8L,0x293a22a87c7b8224L,0x2d9500937ccdc8c0L,0x8a577647206737e9L,
	0xf94d2f8f21555b84L,0x3ed4466534ce7f0eL,0x64ff526fd87ce3e7L,0x37b4c5d368130f6aL,
	0x6e98008ff328b475L,0x3bb019028551c849L,0xe3d10f4b6322d8ebL,0x9cfca9645744b6fL,
	0x97a62aae1ce1d2d5L,0xa7b975333a92c45dL,0x1eadc56cfdebfc79L,0xa708b69996145fd2L,
	0xfbfc9419f653b5f3L,0x34ecbff843e13794L,0x5fe907945ce6c0a1L,0x769e177be0e0b66fL,
	0x55677abc4a6d6cc0L,0x71765f290d2bb87eL,0x810f076f2efc7d57L,0xffbd34eda309eba8L,
	0xa16236af4726e653L,0xe8da7ff35746346dL,0x81f60023440ac8f3L,0x7dcfbf351dde1ae2L,
	0x6dc4ccc123075266L,0x4edf2d538bcc83f9L,0xb7a270c97e9f60b1L,0xf660cdab03f03b06L,
	0x35a150f45be711d6L,0x2c32b6a13e130f7eL,0x8c8826eccd18a132L,0x8e332d3e1c1e8b01L,
	0x967b18ff84cf3726L,0xca08660086d78399L,0xb2f219105c2c8ef9L,0x3462feef714a0e44L,
	0x4141becdb31896fdL,0xc72586ef2ca395afL,0x399b1127b3186eefL,0xfbaca654edd11944L,
	0xcdb9f2fdbd2c68a3L,0xd618bcbb1713d866L,0x29c1271b6ffaeee0L,0xa3330817521eedfbL,
	0x23e1f61a7887688L,0xa195a90a5f74a02aL,0x353e0b46e91addfcL,0xe15f18764de26865L,
	0xb500d980cee8debeL,0xb92ee2526d66f7a9L,0x826e20fd0e1c7557L,0xfcb2b9c023bdbb04L,
	0x273b251498b9637aL,0xb5e83a5ef27fa458L,0xd2f0690082673069L,0x1fa8eadda7813b5dL,
	0x9df0868cb5304b97L,0x7b5b54d144123aebL,0x19893c0c103e358eL,0x9dfd45c697433e79L,
	0x732e58c48b4d312L,0x97688d9a869a43e0L,0x12b1d54a424d4e86L,0x12f4ce0a47e70565L,
	0xae103f67a4732b8fL,0x47ae2f865a746ff5L,0x9a9eacdd27ac70f6L,0xd9820f495de4b9b2L,
	0x5a9429ab90400cd2L,0x993ffaac3dd9dcaeL,0x4ac6a258049bd6e6L,0xe05e8bb7d36479f5L,
	0xbe8724958a2dd547L,0x6c58fafca44f68d1L,0x6034f743f87aa742L,0x45737aa1dcfe7648L,
	0xbad5bd98ca753a7cL,0xe301aebcd7fb18e9L,0xb30199e6fba2e59L,0x752bd6e456b21cc7L,
	0xdcc981dd4c9389a1L,0xe6e47d0415918bc6L,0xfff3e568ecfa661L,0xc389bd7042e65615L,
	0x6d7dc0b998c0780fL,0xffca7c3cf7cd7efaL,0xfd8cbd2a1668ff1L,0x96191bcb8d84d1d4L,
	0x913a1e408b1d83beL,0xa97a88a733a3635eL,0xe843946aff559a84L,0x3f19ae90b5826330L,
	0x3f9cf5b2e040e3cdL,0xb4f4aad6daa3018bL,0x5674e0eac7181cfdL,0x9b7a4fec37666d55L,
	0x50bf8c06e0fe08feL,0x643ce33d5392e62L,0x73754b1443ce1e1eL,0x5e7f961e93a35ff4L,
	0x76be1268218dae37L,0x2d5fc77a0ac38f85L,0xad16681ad304ed0fL,0xb72fc20093d243c3L,
	0xbe4d78b4ea777902L,0xedd9ab37b9a86fdbL,0x97034327a4ca49deL,0xa4ddfd7a022356faL,
	0x1c490fff8bdf2a0dL,0xc64c7451d5e4a410L,0x4e75a7d7becc1df9L,0xe16eea095e95b9d6L,
	0xa161fd0f8e175dabL,0xedcbfa7ee0c17f12L,0x325a3cbc4186c4b5L,0xc1307f3e3dc82b19L,
	0x285a7adf6c9bdc52L,0xacc38ca90a4d695L,0x60ed6dd80cc3e3cbL,0xc95f393ee574d488L,
	0xb676ed1b4ad57b1bL,0x1c3ae416cc2d1790L,0xc31b272386ebd3d5L,0x7b297476aea276cL,
	0x510ec2a8dc498c45L,0xaac55193f00b6abeL,0x6d2b5f0f78eb98d6L,0x668aea231012c912L,
	0xbe67281d8c16dfb3L,0x5d84ad4c134de91eL,0xc38570f6a6b16aafL,0x529a72b2dbde8f4bL,
	0x83418a43c9e25369L,0x7a8a8099020be074L,0x219447b20a81cdabL,0x823d06f731e8cecL,
	0x71c7e89c4494f412L,0xb10788abf2a627c5L,0xb81558085fa73af4L,0xc727bfdf07262e4fL,
	0x49c0f7d5c58dad7dL,0xc806dd068e0d83dfL,0xf75c6b35f73e591bL,0xff1c2921c7c365d1L,
	0x3d36145a51288b1bL,0x71f76602bfc11bcfL,0x2156396ba820c494L,0x3c067e67a65fe852L,
	0xa7f504c22bbd8883L,0x927da34ae676fd68L,0x8e53d45009306837L,0x40136a78605d79b8L,
	0xeb978c5e6478f1efL,0xb947c25f6aa0b1c3L,0xc6e8e17a0b8565c1L,0x3e05cf2ab6ff496cL,
	0x2cfacdad91af54bcL,0x71de0513743de1b9L,0xd466a4f678408e51L,0x9a1713ef73725edbL,
	0xa3507cec7c8effeeL,0x4da9780d75af0a6bL,0x10bddbc4cc046aebL,0xf022c44555c715f6L,
	0x4433e27f945114a9L,0x3aaaf949857a41bbL,0x4dd1665b6856d4f8L,0x5f377e4255edabb2L,
	0xdb6cad89234c26b9L,0xce9c8e990d340ad0L,0x6383c322196d1ec4L,0x43e73111ae07da89L,
	0x849965b6a8a6d0bL,0xab770c1e27fe3a96L,0x130958f67d24cbffL,0x9bf0ab70fda186f8L,
	0x2dbcd0fafac58232L,0x7960ad1274eec3cL,0xb54991a7ee2ada3dL,0x471c7a3075a27bffL,
	0x1da44fa4dbe9b4e3L,0xb0f42efd18f185b4L,0x5958c47b34939976L,0x3a6716b6650b37a4L,
	0x2ae7d5475682e879L,0x9839bec0d573cc36L,0xcf54f0aa63651486L,0x83d2657baecec770L,
	0x5956d8037cb50572L,0xd978892127108bdL,0x9b2f47dff8d609aeL,0xae78848fa95bb4f0L,
	0x957033b0e2a1f9efL,0x5ea819b7306d3c88L,0xf22c88bd8d437311L,0xafb9ea12a8a60235L,
	0x397dac5a505f4a38L,0x71d144cc0032659bL,0xb52629581b1e9f38L,0x7a0d2bafbc43655L,
	0xa8ad40bd99dd3136L,0x50dff83f87e1d33bL,0xd0d651b83055d98fL,0x27d40052777179e8L,
	0x74124ccf336150f8L,0x51d864d5e42b8a76L,0x8cb8a65a27f9a2e5L,0x85b2c833bf06c38bL,
	0x50b87c338b76f32fL,0xb2347427be5dba99L,0x1849e2aee12079f0L,0xf57471d55dbd1460L,
	0x21328cc6ad76d9b1L,0x60a8f1f743e41b7L,0x15b0439a464b33c7L,0xd64e5396a4ac48cL,
	0x784ee11732089ef9L,0xd1d6b47bfae04129L,0xf816c1f65ecbe466L
};

uint8_t PKPtab[8][256] = {
	{(uint8_t)0x73,(uint8_t)0xd5,(uint8_t)0x1a,(uint8_t)0xbb,(uint8_t)0xd8,(uint8_t)0x9c,(uint8_t)0xb8,(uint8_t)0x19,(uint8_t)0x6f,(uint8_t)0xe,(uint8_t)0xfb,(uint8_t)0x68,(uint8_t)0x92,(uint8_t)0xf9,(uint8_t)0x4d,(uint8_t)0x68,(uint8_t)0xfc,(uint8_t)0xcc,(uint8_t)0x2c,(uint8_t)0x35,(uint8_t)0xf0,(uint8_t)0xb8,(uint8_t)0x46,(uint8_t)0x9,(uint8_t)0xe5,(uint8_t)0xf1,(uint8_t)0x2c,(uint8_t)0x55,(uint8_t)0xdd,(uint8_t)0x85,(uint8_t)0xab,(uint8_t)0xa8,(uint8_t)0xd5,(uint8_t)0xd9,(uint8_t)0xbe,(uint8_t)0xf7,(uint8_t)0x68,(uint8_t)0x8,(uint8_t)0xf3,(uint8_t)0xb5,(uint8_t)0x72,(uint8_t)0xe5,(uint8_t)0x90,(uint8_t)0x1,(uint8_t)0x12,(uint8_t)0xb8,(uint8_t)0x19,(uint8_t)0x27,(uint8_t)0xba,(uint8_t)0x5b,(uint8_t)0xb5,(uint8_t)0xf6,(uint8_t)0x7e,(uint8_t)0x1b,(uint8_t)0xda,(uint8_t)0x28,(uint8_t)0xb4,(uint8_t)0x4,(uint8_t)0x9b,(uint8_t)0xf0,(uint8_t)0xe4,(uint8_t)0xae,(uint8_t)0xd7,(uint8_t)0x8d,(uint8_t)0xb1,(uint8_t)0x5d,(uint8_t)0x7b,(uint8_t)0xf2,(uint8_t)0xfc,(uint8_t)0xc,(uint8_t)0x34,(uint8_t)0xe9,(uint8_t)0xa9,(uint8_t)0x9d,(uint8_t)0xe4,(uint8_t)0xef,(uint8_t)0x3b,(uint8_t)0xc2,(uint8_t)0xb1,(uint8_t)0x7c,(uint8_t)0x81,(uint8_t)0x37,(uint8_t)0xad,(uint8_t)0x65,(uint8_t)0x98,(uint8_t)0x78,(uint8_t)0xf9,(uint8_t)0xe9,(uint8_t)0x3d,(uint8_t)0xf1,(uint8_t)0xf6,(uint8_t)0x58,(uint8_t)0x36,(uint8_t)0x7a,(uint8_t)0xca,(uint8_t)0x28,(uint8_t)0x64,(uint8_t)0x52,(uint8_t)0x47,(uint8_t)0x4b,(uint8_t)0x9e,(uint8_t)0xf3,(uint8_t)0x76,(uint8_t)0x5e,(uint8_t)0x24,(uint8_t)0xe9,(uint8_t)0xa8,(uint8_t)0x81,(uint8_t)0x73,(uint8_t)0x72,(uint8_t)0x4d,(uint8_t)0xdd,(uint8_t)0xfb,(uint8_t)0x4,(uint8_t)0xb0,(uint8_t)0x1d,(uint8_t)0xcc,(uint8_t)0xeb,(uint8_t)0xc,(uint8_t)0x8a,(uint8_t)0xea,(uint8_t)0xd6,(uint8_t)0x41,(uint8_t)0xc5,(uint8_t)0x8d,(uint8_t)0xad,(uint8_t)0x56,(uint8_t)0x95,(uint8_t)0x81,(uint8_t)0xba,(uint8_t)0xee,(uint8_t)0xa8,(uint8_t)0x7c,(uint8_t)0x10,(uint8_t)0xd4,(uint8_t)0xa,(uint8_t)0x47,(uint8_t)0x90,(uint8_t)0x20,(uint8_t)0x28,(uint8_t)0xe6,(uint8_t)0x1c,(uint8_t)0xfd,(uint8_t)0xc2,(uint8_t)0x43,(uint8_t)0xd9,(uint8_t)0xd1,(uint8_t)0x60,(uint8_t)0x8,(uint8_t)0xaa,(uint8_t)0xbc,(uint8_t)0x9f,(uint8_t)0xb7,(uint8_t)0x7c,(uint8_t)0xc7,(uint8_t)0x23,(uint8_t)0xa5,(uint8_t)0x60,(uint8_t)0x17,(uint8_t)0xe1,(uint8_t)0x4f,(uint8_t)0x1c,(uint8_t)0xe8,(uint8_t)0xb1,(uint8_t)0x69,(uint8_t)0x83,(uint8_t)0x41,(uint8_t)0x73,(uint8_t)0x4a,(uint8_t)0x68,(uint8_t)0x23,(uint8_t)0xce,(uint8_t)0x2,(uint8_t)0x4,(uint8_t)0x3e,(uint8_t)0x1,(uint8_t)0x6b,(uint8_t)0x54,(uint8_t)0x49,(uint8_t)0x1,(uint8_t)0x21,(uint8_t)0x4a,(uint8_t)0x2d,(uint8_t)0xda,(uint8_t)0xb8,(uint8_t)0x2f,(uint8_t)0xec,(uint8_t)0x85,(uint8_t)0xc0,(uint8_t)0xb9,(uint8_t)0xfe,(uint8_t)0x5,(uint8_t)0x49,(uint8_t)0xc4,(uint8_t)0x75,(uint8_t)0xbe,(uint8_t)0x5b,(uint8_t)0x88,(uint8_t)0x7b,(uint8_t)0xb4,(uint8_t)0xb8,(uint8_t)0x99,(uint8_t)0x5b,(uint8_t)0x24,(uint8_t)0xfb,(uint8_t)0x5c,(uint8_t)0x68,(uint8_t)0x46,(uint8_t)0xf8,(uint8_t)0x8b,(uint8_t)0x52,(uint8_t)0x7b,(uint8_t)0x4f,(uint8_t)0x9d,(uint8_t)0x4c,(uint8_t)0x13,(uint8_t)0x91,(uint8_t)0xf1,(uint8_t)0x67,(uint8_t)0x8b,(uint8_t)0x23,(uint8_t)0xba,(uint8_t)0x4f,(uint8_t)0x9c,(uint8_t)0x9c,(uint8_t)0xd7,(uint8_t)0xbc,(uint8_t)0x93,(uint8_t)0xeb,(uint8_t)0x57,(uint8_t)0x76,(uint8_t)0xf4,(uint8_t)0xf0,(uint8_t)0x36,(uint8_t)0x75,(uint8_t)0x34,(uint8_t)0x48,(uint8_t)0x64,(uint8_t)0x29,(uint8_t)0x46,(uint8_t)0x61,(uint8_t)0xc5,(uint8_t)0x94,(uint8_t)0x9f,(uint8_t)0xaf,(uint8_t)0x17,(uint8_t)0xb1,(uint8_t)0x30,(uint8_t)0xfc,(uint8_t)0xf6,(uint8_t)0x48,(uint8_t)0x2f,(uint8_t)0x97,(uint8_t)0x1a,(uint8_t)0x55},
	{(uint8_t)0xac,(uint8_t)0x36,(uint8_t)0xbc,(uint8_t)0x2,(uint8_t)0xd8,(uint8_t)0x97,(uint8_t)0xfb,(uint8_t)0xae,(uint8_t)0xa8,(uint8_t)0x22,(uint8_t)0x3a,(uint8_t)0x29,(uint8_t)0x24,(uint8_t)0x82,(uint8_t)0x7b,(uint8_t)0x7c,(uint8_t)0x93,(uint8_t)0x0,(uint8_t)0x95,(uint8_t)0x2d,(uint8_t)0xc0,(uint8_t)0xc8,(uint8_t)0xcd,(uint8_t)0x7c,(uint8_t)0x47,(uint8_t)0x76,(uint8_t)0x57,(uint8_t)0x8a,(uint8_t)0xe9,(uint8_t)0x37,(uint8_t)0x67,(uint8_t)0x20,(uint8_t)0x8f,(uint8_t)0x2f,(uint8_t)0x4d,(uint8_t)0xf9,(uint8_t)0x84,(uint8_t)0x5b,(uint8_t)0x55,(uint8_t)0x21,(uint8_t)0x65,(uint8_t)0x46,(uint8_t)0xd4,(uint8_t)0x3e,(uint8_t)0xe,(uint8_t)0x7f,(uint8_t)0xce,(uint8_t)0x34,(uint8_t)0x70,(uint8_t)0x52,(uint8_t)0xff,(uint8_t)0x64,(uint8_t)0xe7,(uint8_t)0xe3,(uint8_t)0x7c,(uint8_t)0xd8,(uint8_t)0xd3,(uint8_t)0xc5,(uint8_t)0xb4,(uint8_t)0x37,(uint8_t)0x6a,(uint8_t)0xf,(uint8_t)0x13,(uint8_t)0x68,(uint8_t)0x90,(uint8_t)0x0,(uint8_t)0x98,(uint8_t)0x6e,(uint8_t)0x75,(uint8_t)0xb4,(uint8_t)0x28,(uint8_t)0xf3,(uint8_t)0x3,(uint8_t)0x19,(uint8_t)0xb0,(uint8_t)0x3b,(uint8_t)0x49,(uint8_t)0xc8,(uint8_t)0x51,(uint8_t)0x85,(uint8_t)0x4b,(uint8_t)0xf,(uint8_t)0xd1,(uint8_t)0xe3,(uint8_t)0xeb,(uint8_t)0xd8,(uint8_t)0x22,(uint8_t)0x63,(uint8_t)0x96,(uint8_t)0xca,(uint8_t)0xcf,(uint8_t)0x9,(uint8_t)0x6f,(uint8_t)0x4b,(uint8_t)0x74,(uint8_t)0x45,(uint8_t)0xae,(uint8_t)0x2a,(uint8_t)0xa6,(uint8_t)0x97,(uint8_t)0xd5,(uint8_t)0xd2,(uint8_t)0xe1,(uint8_t)0x1c,(uint8_t)0x33,(uint8_t)0x75,(uint8_t)0xb9,(uint8_t)0xa7,(uint8_t)0x5d,(uint8_t)0xc4,(uint8_t)0x92,(uint8_t)0x3a,(uint8_t)0x6d,(uint8_t)0xc5,(uint8_t)0xad,(uint8_t)0x1e,(uint8_t)0x79,(uint8_t)0xfc,(uint8_t)0xeb,(uint8_t)0xfd,(uint8_t)0x9a,(uint8_t)0xb6,(uint8_t)0x8,(uint8_t)0xa7,(uint8_t)0xd2,(uint8_t)0x5f,(uint8_t)0x14,(uint8_t)0x96,(uint8_t)0x1a,(uint8_t)0x94,(uint8_t)0xfc,(uint8_t)0xfb,(uint8_t)0xf3,(uint8_t)0xb5,(uint8_t)0x53,(uint8_t)0xf6,(uint8_t)0xf8,(uint8_t)0xbf,(uint8_t)0xec,(uint8_t)0x34,(uint8_t)0x94,(uint8_t)0x37,(uint8_t)0xe1,(uint8_t)0x43,(uint8_t)0x94,(uint8_t)0x7,(uint8_t)0xe9,(uint8_t)0x5f,(uint8_t)0xa1,(uint8_t)0xc0,(uint8_t)0xe6,(uint8_t)0x5c,(uint8_t)0x7c,(uint8_t)0x17,(uint8_t)0x9e,(uint8_t)0x76,(uint8_t)0x6f,(uint8_t)0xb6,(uint8_t)0xe0,(uint8_t)0xe0,(uint8_t)0xbc,(uint8_t)0x7a,(uint8_t)0x67,(uint8_t)0x55,(uint8_t)0xc0,(uint8_t)0x6c,(uint8_t)0x6d,(uint8_t)0x4a,(uint8_t)0x29,(uint8_t)0x5f,(uint8_t)0x76,(uint8_t)0x71,(uint8_t)0x7e,(uint8_t)0xb8,(uint8_t)0x2b,(uint8_t)0xd,(uint8_t)0x6f,(uint8_t)0x7,(uint8_t)0xf,(uint8_t)0x81,(uint8_t)0x57,(uint8_t)0x7d,(uint8_t)0xfc,(uint8_t)0x2e,(uint8_t)0xee,(uint8_t)0x34,(uint8_t)0xbd,(uint8_t)0xff,(uint8_t)0xa8,(uint8_t)0xeb,(uint8_t)0x9,(uint8_t)0xa3,(uint8_t)0xaf,(uint8_t)0x36,(uint8_t)0x62,(uint8_t)0xa1,(uint8_t)0x53,(uint8_t)0xe6,(uint8_t)0x26,(uint8_t)0x47,(uint8_t)0xf3,(uint8_t)0x7f,(uint8_t)0xda,(uint8_t)0xe8,(uint8_t)0x6d,(uint8_t)0x34,(uint8_t)0x46,(uint8_t)0x57,(uint8_t)0x23,(uint8_t)0x0,(uint8_t)0xf6,(uint8_t)0x81,(uint8_t)0xf3,(uint8_t)0xc8,(uint8_t)0xa,(uint8_t)0x44,(uint8_t)0x35,(uint8_t)0xbf,(uint8_t)0xcf,(uint8_t)0x7d,(uint8_t)0xe2,(uint8_t)0x1a,(uint8_t)0xde,(uint8_t)0x1d,(uint8_t)0xc1,(uint8_t)0xcc,(uint8_t)0xc4,(uint8_t)0x6d,(uint8_t)0x66,(uint8_t)0x52,(uint8_t)0x7,(uint8_t)0x23,(uint8_t)0x54,(uint8_t)0x2d,(uint8_t)0xdf,(uint8_t)0x4e,(uint8_t)0xf9,(uint8_t)0x83,(uint8_t)0xcc,(uint8_t)0x8b,(uint8_t)0xc9,(uint8_t)0x70,(uint8_t)0xa2,(uint8_t)0xb7,(uint8_t)0xb1,(uint8_t)0x60,(uint8_t)0x9f,(uint8_t)0x7e,(uint8_t)0xab,(uint8_t)0xcd,(uint8_t)0x60,(uint8_t)0xf6,(uint8_t)0x6,(uint8_t)0x3b,(uint8_t)0xf0},
	{(uint8_t)0xf4,(uint8_t)0x50,(uint8_t)0xa1,(uint8_t)0x35,(uint8_t)0xd6,(uint8_t)0x11,(uint8_t)0xe7,(uint8_t)0x5b,(uint8_t)0xa1,(uint8_t)0xb6,(uint8_t)0x32,(uint8_t)0x2c,(uint8_t)0x7e,(uint8_t)0xf,(uint8_t)0x13,(uint8_t)0x3e,(uint8_t)0xed,(uint8_t)0x26,(uint8_t)0x88,(uint8_t)0x8c,(uint8_t)0x32,(uint8_t)0xa1,(uint8_t)0x18,(uint8_t)0xcd,(uint8_t)0x3e,(uint8_t)0x2d,(uint8_t)0x33,(uint8_t)0x8e,(uint8_t)0x1,(uint8_t)0x8b,(uint8_t)0x1e,(uint8_t)0x1c,(uint8_t)0x0,(uint8_t)0x19,(uint8_t)0x7b,(uint8_t)0x96,(uint8_t)0x26,(uint8_t)0x37,(uint8_t)0xcf,(uint8_t)0x84,(uint8_t)0x1,(uint8_t)0x66,(uint8_t)0x8,(uint8_t)0xca,(uint8_t)0x99,(uint8_t)0x83,(uint8_t)0xd7,(uint8_t)0x86,(uint8_t)0x10,(uint8_t)0x19,(uint8_t)0xf2,(uint8_t)0xb2,(uint8_t)0xf9,(uint8_t)0x8e,(uint8_t)0x2c,(uint8_t)0x5c,(uint8_t)0xef,(uint8_t)0xfe,(uint8_t)0x62,(uint8_t)0x34,(uint8_t)0x44,(uint8_t)0xe,(uint8_t)0x4a,(uint8_t)0x71,(uint8_t)0xce,(uint8_t)0xbe,(uint8_t)0x41,(uint8_t)0x41,(uint8_t)0xfd,(uint8_t)0x96,(uint8_t)0x18,(uint8_t)0xb3,(uint8_t)0xef,(uint8_t)0x86,(uint8_t)0x25,(uint8_t)0xc7,(uint8_t)0xaf,(uint8_t)0x95,(uint8_t)0xa3,(uint8_t)0x2c,(uint8_t)0x28,(uint8_t)0x11,(uint8_t)0x9b,(uint8_t)0x39,(uint8_t)0xef,(uint8_t)0x6e,(uint8_t)0x18,(uint8_t)0xb3,(uint8_t)0x55,(uint8_t)0xa6,(uint8_t)0xac,(uint8_t)0xfb,(uint8_t)0x44,(uint8_t)0x19,(uint8_t)0xd1,(uint8_t)0xed,(uint8_t)0xfe,(uint8_t)0xf2,(uint8_t)0xb9,(uint8_t)0xcd,(uint8_t)0xa3,(uint8_t)0x68,(uint8_t)0x2c,(uint8_t)0xbd,(uint8_t)0xbb,(uint8_t)0xbc,(uint8_t)0x18,(uint8_t)0xd6,(uint8_t)0x66,(uint8_t)0xd8,(uint8_t)0x13,(uint8_t)0x17,(uint8_t)0x1b,(uint8_t)0x27,(uint8_t)0xc1,(uint8_t)0x29,(uint8_t)0xe0,(uint8_t)0xee,(uint8_t)0xfa,(uint8_t)0x6f,(uint8_t)0x17,(uint8_t)0x8,(uint8_t)0x33,(uint8_t)0xa3,(uint8_t)0xfb,(uint8_t)0xed,(uint8_t)0x1e,(uint8_t)0x52,(uint8_t)0x62,(uint8_t)0x1f,(uint8_t)0x3e,(uint8_t)0x2,(uint8_t)0x88,(uint8_t)0x76,(uint8_t)0x88,(uint8_t)0xa7,(uint8_t)0xa,(uint8_t)0xa9,(uint8_t)0x95,(uint8_t)0xa1,(uint8_t)0x2a,(uint8_t)0xa0,(uint8_t)0x74,(uint8_t)0x5f,(uint8_t)0x47,(uint8_t)0xb,(uint8_t)0x3e,(uint8_t)0x35,(uint8_t)0xfc,(uint8_t)0xdd,(uint8_t)0x1a,(uint8_t)0xe9,(uint8_t)0x76,(uint8_t)0x18,(uint8_t)0x5f,(uint8_t)0xe1,(uint8_t)0x65,(uint8_t)0x68,(uint8_t)0xe2,(uint8_t)0x4d,(uint8_t)0x81,(uint8_t)0xd9,(uint8_t)0x0,(uint8_t)0xb5,(uint8_t)0xbe,(uint8_t)0xde,(uint8_t)0xe8,(uint8_t)0xce,(uint8_t)0x52,(uint8_t)0xe2,(uint8_t)0x2e,(uint8_t)0xb9,(uint8_t)0xa9,(uint8_t)0xf7,(uint8_t)0x66,(uint8_t)0x6d,(uint8_t)0xfd,(uint8_t)0x20,(uint8_t)0x6e,(uint8_t)0x82,(uint8_t)0x57,(uint8_t)0x75,(uint8_t)0x1c,(uint8_t)0xe,(uint8_t)0xc0,(uint8_t)0xb9,(uint8_t)0xb2,(uint8_t)0xfc,(uint8_t)0x4,(uint8_t)0xbb,(uint8_t)0xbd,(uint8_t)0x23,(uint8_t)0x15,(uint8_t)0x25,(uint8_t)0x3b,(uint8_t)0x27,(uint8_t)0x7a,(uint8_t)0x63,(uint8_t)0xb9,(uint8_t)0x98,(uint8_t)0x5f,(uint8_t)0x3a,(uint8_t)0xe8,(uint8_t)0xb5,(uint8_t)0x58,(uint8_t)0xa4,(uint8_t)0x7f,(uint8_t)0xf2,(uint8_t)0x1,(uint8_t)0x69,(uint8_t)0xf0,(uint8_t)0xd2,(uint8_t)0x69,(uint8_t)0x30,(uint8_t)0x67,(uint8_t)0x82,(uint8_t)0xde,(uint8_t)0xea,(uint8_t)0xa8,(uint8_t)0x1f,(uint8_t)0x5d,(uint8_t)0x3b,(uint8_t)0x81,(uint8_t)0xa7,(uint8_t)0x8d,(uint8_t)0x86,(uint8_t)0xf0,(uint8_t)0x9d,(uint8_t)0x97,(uint8_t)0x4b,(uint8_t)0x30,(uint8_t)0xb5,(uint8_t)0xd1,(uint8_t)0x54,(uint8_t)0x5b,(uint8_t)0x7b,(uint8_t)0xeb,(uint8_t)0x3a,(uint8_t)0x12,(uint8_t)0x44,(uint8_t)0xc,(uint8_t)0x3c,(uint8_t)0x89,(uint8_t)0x19,(uint8_t)0x8e,(uint8_t)0x35,(uint8_t)0x3e,(uint8_t)0x10,(uint8_t)0xc7,(uint8_t)0x45,(uint8_t)0xfd,(uint8_t)0x9d,(uint8_t)0x79,(uint8_t)0x3e,(uint8_t)0x43},
	{(uint8_t)0x8c,(uint8_t)0xe5,(uint8_t)0x32,(uint8_t)0x7,(uint8_t)0x12,(uint8_t)0xd3,(uint8_t)0xb4,(uint8_t)0x48,(uint8_t)0x9b,(uint8_t)0x8d,(uint8_t)0x68,(uint8_t)0x97,(uint8_t)0xe0,(uint8_t)0x43,(uint8_t)0x9a,(uint8_t)0x86,(uint8_t)0x4a,(uint8_t)0xd5,(uint8_t)0xb1,(uint8_t)0x12,(uint8_t)0x86,(uint8_t)0x4e,(uint8_t)0x4d,(uint8_t)0x42,(uint8_t)0xa,(uint8_t)0xce,(uint8_t)0xf4,(uint8_t)0x12,(uint8_t)0x65,(uint8_t)0x5,(uint8_t)0xe7,(uint8_t)0x47,(uint8_t)0x68,(uint8_t)0x3f,(uint8_t)0x10,(uint8_t)0xae,(uint8_t)0x8f,(uint8_t)0x2b,(uint8_t)0x73,(uint8_t)0xa4,(uint8_t)0x86,(uint8_t)0x2f,(uint8_t)0xae,(uint8_t)0x47,(uint8_t)0xf5,(uint8_t)0x6f,(uint8_t)0x74,(uint8_t)0x5a,(uint8_t)0xdd,(uint8_t)0xac,(uint8_t)0x9e,(uint8_t)0x9a,(uint8_t)0xf6,(uint8_t)0x70,(uint8_t)0xac,(uint8_t)0x27,(uint8_t)0x49,(uint8_t)0xf,(uint8_t)0x82,(uint8_t)0xd9,(uint8_t)0xb2,(uint8_t)0xb9,(uint8_t)0xe4,(uint8_t)0x5d,(uint8_t)0xac,(uint8_t)0x29,(uint8_t)0x94,(uint8_t)0x5a,(uint8_t)0xd2,(uint8_t)0xc,(uint8_t)0x40,(uint8_t)0x90,(uint8_t)0xac,(uint8_t)0xfa,(uint8_t)0x3f,(uint8_t)0x99,(uint8_t)0xae,(uint8_t)0xdc,(uint8_t)0xd9,(uint8_t)0x3d,(uint8_t)0x58,(uint8_t)0xa2,(uint8_t)0xc6,(uint8_t)0x4a,(uint8_t)0xe6,(uint8_t)0xd6,(uint8_t)0x9b,(uint8_t)0x4,(uint8_t)0xb8,(uint8_t)0x8b,(uint8_t)0x5e,(uint8_t)0xe0,(uint8_t)0xf5,(uint8_t)0x79,(uint8_t)0x64,(uint8_t)0xd3,(uint8_t)0x96,(uint8_t)0x24,(uint8_t)0x87,(uint8_t)0xbe,(uint8_t)0x47,(uint8_t)0xd5,(uint8_t)0x2d,(uint8_t)0x8a,(uint8_t)0xfd,(uint8_t)0xfa,(uint8_t)0x58,(uint8_t)0x6c,(uint8_t)0xd1,(uint8_t)0x68,(uint8_t)0x4f,(uint8_t)0xa4,(uint8_t)0x44,(uint8_t)0xf7,(uint8_t)0x34,(uint8_t)0x60,(uint8_t)0x42,(uint8_t)0xa7,(uint8_t)0x7a,(uint8_t)0xf8,(uint8_t)0xa2,(uint8_t)0x7a,(uint8_t)0x73,(uint8_t)0x45,(uint8_t)0x48,(uint8_t)0x76,(uint8_t)0xfe,(uint8_t)0xdc,(uint8_t)0x99,(uint8_t)0xbd,(uint8_t)0xd5,(uint8_t)0xba,(uint8_t)0x7c,(uint8_t)0x3a,(uint8_t)0x75,(uint8_t)0xca,(uint8_t)0xbd,(uint8_t)0xae,(uint8_t)0x1,(uint8_t)0xe3,(uint8_t)0xe9,(uint8_t)0x18,(uint8_t)0xfb,(uint8_t)0xd7,(uint8_t)0x9e,(uint8_t)0x19,(uint8_t)0x30,(uint8_t)0xb,(uint8_t)0x59,(uint8_t)0x2e,(uint8_t)0xba,(uint8_t)0x6f,(uint8_t)0xe4,(uint8_t)0xd6,(uint8_t)0x2b,(uint8_t)0x75,(uint8_t)0xc7,(uint8_t)0x1c,(uint8_t)0xb2,(uint8_t)0x56,(uint8_t)0xdd,(uint8_t)0x81,(uint8_t)0xc9,(uint8_t)0xdc,(uint8_t)0xa1,(uint8_t)0x89,(uint8_t)0x93,(uint8_t)0x4c,(uint8_t)0x4,(uint8_t)0x7d,(uint8_t)0xe4,(uint8_t)0xe6,(uint8_t)0xc6,(uint8_t)0x8b,(uint8_t)0x91,(uint8_t)0x15,(uint8_t)0x57,(uint8_t)0x3e,(uint8_t)0xff,(uint8_t)0xf,(uint8_t)0x61,(uint8_t)0xa6,(uint8_t)0xcf,(uint8_t)0x8e,(uint8_t)0x70,(uint8_t)0xbd,(uint8_t)0x89,(uint8_t)0xc3,(uint8_t)0x15,(uint8_t)0x56,(uint8_t)0xe6,(uint8_t)0x42,(uint8_t)0xba,(uint8_t)0xc0,(uint8_t)0x7d,(uint8_t)0x6d,(uint8_t)0xf,(uint8_t)0x78,(uint8_t)0xc0,(uint8_t)0x98,(uint8_t)0x3d,(uint8_t)0x7c,(uint8_t)0xca,(uint8_t)0xff,(uint8_t)0xfa,(uint8_t)0x7e,(uint8_t)0xcd,(uint8_t)0xf7,(uint8_t)0xd3,(uint8_t)0xcb,(uint8_t)0xd8,(uint8_t)0xf,(uint8_t)0xf1,(uint8_t)0x8f,(uint8_t)0x66,(uint8_t)0xa1,(uint8_t)0xcc,(uint8_t)0x1b,(uint8_t)0x19,(uint8_t)0x96,(uint8_t)0xd4,(uint8_t)0xd1,(uint8_t)0x84,(uint8_t)0x8d,(uint8_t)0x41,(uint8_t)0x1e,(uint8_t)0x3a,(uint8_t)0x91,(uint8_t)0xbe,(uint8_t)0x83,(uint8_t)0x1d,(uint8_t)0x8b,(uint8_t)0xa7,(uint8_t)0x88,(uint8_t)0x7a,(uint8_t)0xa9,(uint8_t)0x5e,(uint8_t)0x63,(uint8_t)0xa3,(uint8_t)0x33,(uint8_t)0x6b,(uint8_t)0x94,(uint8_t)0x43,(uint8_t)0xe8,(uint8_t)0x84,(uint8_t)0x9a,(uint8_t)0x55,(uint8_t)0xff,(uint8_t)0x91,(uint8_t)0xae,(uint8_t)0x19,(uint8_t)0x3f,(uint8_t)0x30,(uint8_t)0x63,(uint8_t)0x82},
	{(uint8_t)0xb3,(uint8_t)0xf5,(uint8_t)0x9c,(uint8_t)0x3f,(uint8_t)0xcd,(uint8_t)0xe3,(uint8_t)0x40,(uint8_t)0xe0,(uint8_t)0xd7,(uint8_t)0xaa,(uint8_t)0xf4,(uint8_t)0xb4,(uint8_t)0x8b,(uint8_t)0x1,(uint8_t)0xa3,(uint8_t)0xda,(uint8_t)0xeb,(uint8_t)0xe0,(uint8_t)0x74,(uint8_t)0x56,(uint8_t)0xfd,(uint8_t)0x1c,(uint8_t)0x18,(uint8_t)0xc7,(uint8_t)0xec,(uint8_t)0x4f,(uint8_t)0x7a,(uint8_t)0x9b,(uint8_t)0x55,(uint8_t)0x6d,(uint8_t)0x66,(uint8_t)0x37,(uint8_t)0x7,(uint8_t)0x8c,(uint8_t)0xbf,(uint8_t)0x50,(uint8_t)0xfe,(uint8_t)0x8,(uint8_t)0xfe,(uint8_t)0xe0,(uint8_t)0x34,(uint8_t)0xce,(uint8_t)0x43,(uint8_t)0x6,(uint8_t)0x62,(uint8_t)0x2e,(uint8_t)0x39,(uint8_t)0xd5,(uint8_t)0x14,(uint8_t)0x4b,(uint8_t)0x75,(uint8_t)0x73,(uint8_t)0x1e,(uint8_t)0x1e,(uint8_t)0xce,(uint8_t)0x43,(uint8_t)0x1f,(uint8_t)0x96,(uint8_t)0x7f,(uint8_t)0x5e,(uint8_t)0xf4,(uint8_t)0x5f,(uint8_t)0xa3,(uint8_t)0x93,(uint8_t)0x68,(uint8_t)0x12,(uint8_t)0xbe,(uint8_t)0x76,(uint8_t)0x37,(uint8_t)0xae,(uint8_t)0x8d,(uint8_t)0x21,(uint8_t)0x7a,(uint8_t)0xc7,(uint8_t)0x5f,(uint8_t)0x2d,(uint8_t)0x85,(uint8_t)0x8f,(uint8_t)0xc3,(uint8_t)0xa,(uint8_t)0x1b,(uint8_t)0x68,(uint8_t)0x16,(uint8_t)0xad,(uint8_t)0xf,(uint8_t)0xed,(uint8_t)0x4,(uint8_t)0xd3,(uint8_t)0x1,(uint8_t)0xc2,(uint8_t)0x2f,(uint8_t)0xb7,(uint8_t)0xc3,(uint8_t)0x43,(uint8_t)0xd2,(uint8_t)0x93,(uint8_t)0xb5,(uint8_t)0x78,(uint8_t)0x4d,(uint8_t)0xbe,(uint8_t)0x2,(uint8_t)0x79,(uint8_t)0x77,(uint8_t)0xea,(uint8_t)0x38,(uint8_t)0xab,(uint8_t)0xd9,(uint8_t)0xed,(uint8_t)0xdb,(uint8_t)0x6f,(uint8_t)0xa8,(uint8_t)0xb9,(uint8_t)0x28,(uint8_t)0x43,(uint8_t)0x3,(uint8_t)0x97,(uint8_t)0xde,(uint8_t)0x49,(uint8_t)0xca,(uint8_t)0xa4,(uint8_t)0x7a,(uint8_t)0xfd,(uint8_t)0xdd,(uint8_t)0xa4,(uint8_t)0xfa,(uint8_t)0x56,(uint8_t)0x23,(uint8_t)0x2,(uint8_t)0x0,(uint8_t)0x10,(uint8_t)0x49,(uint8_t)0x1c,(uint8_t)0xd,(uint8_t)0x2a,(uint8_t)0xdf,(uint8_t)0x8b,(uint8_t)0x52,(uint8_t)0x74,(uint8_t)0x4c,(uint8_t)0xc6,(uint8_t)0x10,(uint8_t)0xa4,(uint8_t)0xe4,(uint8_t)0xd5,(uint8_t)0xd8,(uint8_t)0xa7,(uint8_t)0x75,(uint8_t)0x4e,(uint8_t)0xf9,(uint8_t)0x1d,(uint8_t)0xcc,(uint8_t)0xbe,(uint8_t)0x9,(uint8_t)0xea,(uint8_t)0x6e,(uint8_t)0xe1,(uint8_t)0xd6,(uint8_t)0xb9,(uint8_t)0x95,(uint8_t)0x5e,(uint8_t)0x10,(uint8_t)0xfd,(uint8_t)0x61,(uint8_t)0xa1,(uint8_t)0xab,(uint8_t)0x5d,(uint8_t)0x17,(uint8_t)0x8e,(uint8_t)0x7f,(uint8_t)0xfa,(uint8_t)0xcb,(uint8_t)0xed,(uint8_t)0x12,(uint8_t)0x7f,(uint8_t)0xc1,(uint8_t)0xe0,(uint8_t)0xbc,(uint8_t)0x3c,(uint8_t)0x5a,(uint8_t)0x32,(uint8_t)0xb5,(uint8_t)0xc4,(uint8_t)0x86,(uint8_t)0x41,(uint8_t)0x3e,(uint8_t)0x7f,(uint8_t)0x30,(uint8_t)0xc1,(uint8_t)0x19,(uint8_t)0x2b,(uint8_t)0xc8,(uint8_t)0x3d,(uint8_t)0xdf,(uint8_t)0x7a,(uint8_t)0x5a,(uint8_t)0x28,(uint8_t)0x52,(uint8_t)0xdc,(uint8_t)0x9b,(uint8_t)0x6c,(uint8_t)0xcb,(uint8_t)0x38,(uint8_t)0xcc,(uint8_t)0xa,(uint8_t)0x95,(uint8_t)0xd6,(uint8_t)0xa4,(uint8_t)0x90,(uint8_t)0xd8,(uint8_t)0x6d,(uint8_t)0xed,(uint8_t)0x60,(uint8_t)0xcb,(uint8_t)0xe3,(uint8_t)0xc3,(uint8_t)0xc,(uint8_t)0x3f,(uint8_t)0x39,(uint8_t)0x5f,(uint8_t)0xc9,(uint8_t)0x88,(uint8_t)0xd4,(uint8_t)0x74,(uint8_t)0xe5,(uint8_t)0x1b,(uint8_t)0xed,(uint8_t)0x76,(uint8_t)0xb6,(uint8_t)0x1b,(uint8_t)0x7b,(uint8_t)0xd5,(uint8_t)0x4a,(uint8_t)0x17,(uint8_t)0xe4,(uint8_t)0x3a,(uint8_t)0x1c,(uint8_t)0x90,(uint8_t)0x17,(uint8_t)0x2d,(uint8_t)0xcc,(uint8_t)0x24,(uint8_t)0x27,(uint8_t)0x1b,(uint8_t)0xc3,(uint8_t)0xd5,(uint8_t)0xd3,(uint8_t)0xeb,(uint8_t)0x86,(uint8_t)0x47,(uint8_t)0x97,(uint8_t)0xb2,(uint8_t)0x7,(uint8_t)0x6c,(uint8_t)0x27,(uint8_t)0xea},
	{(uint8_t)0xa9,(uint8_t)0xc2,(uint8_t)0xe,(uint8_t)0x51,(uint8_t)0x45,(uint8_t)0x8c,(uint8_t)0x49,(uint8_t)0xdc,(uint8_t)0x94,(uint8_t)0x51,(uint8_t)0xc5,(uint8_t)0xaa,(uint8_t)0xbe,(uint8_t)0x6a,(uint8_t)0xb,(uint8_t)0xf0,(uint8_t)0xf,(uint8_t)0x5f,(uint8_t)0x2b,(uint8_t)0x6d,(uint8_t)0xd6,(uint8_t)0x98,(uint8_t)0xeb,(uint8_t)0x78,(uint8_t)0x23,(uint8_t)0xea,(uint8_t)0x8a,(uint8_t)0x66,(uint8_t)0x12,(uint8_t)0xc9,(uint8_t)0x12,(uint8_t)0x10,(uint8_t)0x1e,(uint8_t)0x28,(uint8_t)0x67,(uint8_t)0xbe,(uint8_t)0xb3,(uint8_t)0xdf,(uint8_t)0x16,(uint8_t)0x8c,(uint8_t)0x4c,(uint8_t)0xad,(uint8_t)0x84,(uint8_t)0x5d,(uint8_t)0x1e,(uint8_t)0xe9,(uint8_t)0x4d,(uint8_t)0x13,(uint8_t)0xf7,(uint8_t)0x70,(uint8_t)0x85,(uint8_t)0xc3,(uint8_t)0xaf,(uint8_t)0x6a,(uint8_t)0xb1,(uint8_t)0xa6,(uint8_t)0xb3,(uint8_t)0x72,(uint8_t)0x9a,(uint8_t)0x52,(uint8_t)0x4b,(uint8_t)0x8f,(uint8_t)0xde,(uint8_t)0xdb,(uint8_t)0x44,(uint8_t)0x8a,(uint8_t)0x41,(uint8_t)0x83,(uint8_t)0x69,(uint8_t)0x53,(uint8_t)0xe2,(uint8_t)0xc9,(uint8_t)0x99,(uint8_t)0x80,(uint8_t)0x8a,(uint8_t)0x7a,(uint8_t)0x74,(uint8_t)0xe0,(uint8_t)0xb,(uint8_t)0x2,(uint8_t)0xb2,(uint8_t)0x47,(uint8_t)0x94,(uint8_t)0x21,(uint8_t)0xab,(uint8_t)0xcd,(uint8_t)0x81,(uint8_t)0xa,(uint8_t)0x6f,(uint8_t)0xd0,(uint8_t)0x23,(uint8_t)0x8,(uint8_t)0xec,(uint8_t)0x8c,(uint8_t)0x1e,(uint8_t)0x73,(uint8_t)0x9c,(uint8_t)0xe8,(uint8_t)0xc7,(uint8_t)0x71,(uint8_t)0x12,(uint8_t)0xf4,(uint8_t)0x94,(uint8_t)0x44,(uint8_t)0xac,(uint8_t)0x88,(uint8_t)0x7,(uint8_t)0xb1,(uint8_t)0xc5,(uint8_t)0x27,(uint8_t)0xa6,(uint8_t)0xf2,(uint8_t)0x8,(uint8_t)0x58,(uint8_t)0x15,(uint8_t)0xb8,(uint8_t)0xf4,(uint8_t)0x3a,(uint8_t)0xa7,(uint8_t)0x5f,(uint8_t)0xdf,(uint8_t)0xbf,(uint8_t)0x27,(uint8_t)0xc7,(uint8_t)0x4f,(uint8_t)0x2e,(uint8_t)0x26,(uint8_t)0x7,(uint8_t)0xd6,(uint8_t)0xf7,(uint8_t)0xc0,(uint8_t)0x49,(uint8_t)0x7d,(uint8_t)0xad,(uint8_t)0x8d,(uint8_t)0xc5,(uint8_t)0x7,(uint8_t)0xdd,(uint8_t)0x6,(uint8_t)0xc8,(uint8_t)0xdf,(uint8_t)0x83,(uint8_t)0xd,(uint8_t)0x8e,(uint8_t)0x36,(uint8_t)0x6b,(uint8_t)0x5c,(uint8_t)0xf7,(uint8_t)0x1b,(uint8_t)0x59,(uint8_t)0x3e,(uint8_t)0xf7,(uint8_t)0x22,(uint8_t)0x29,(uint8_t)0x1c,(uint8_t)0xff,(uint8_t)0xd1,(uint8_t)0x65,(uint8_t)0xc3,(uint8_t)0xc7,(uint8_t)0x5a,(uint8_t)0x14,(uint8_t)0x36,(uint8_t)0x3d,(uint8_t)0x1b,(uint8_t)0x8b,(uint8_t)0x28,(uint8_t)0x51,(uint8_t)0x3,(uint8_t)0x66,(uint8_t)0xf7,(uint8_t)0x71,(uint8_t)0xcf,(uint8_t)0x1b,(uint8_t)0xc1,(uint8_t)0xbf,(uint8_t)0x6c,(uint8_t)0x39,(uint8_t)0x56,(uint8_t)0x21,(uint8_t)0x94,(uint8_t)0xc4,(uint8_t)0x20,(uint8_t)0xa8,(uint8_t)0x68,(uint8_t)0x7e,(uint8_t)0x6,(uint8_t)0x3c,(uint8_t)0x52,(uint8_t)0xe8,(uint8_t)0x5f,(uint8_t)0xa6,(uint8_t)0xc2,(uint8_t)0x4,(uint8_t)0xf5,(uint8_t)0xa7,(uint8_t)0x83,(uint8_t)0x88,(uint8_t)0xbd,(uint8_t)0x2b,(uint8_t)0x4b,(uint8_t)0xa3,(uint8_t)0x7d,(uint8_t)0x92,(uint8_t)0x68,(uint8_t)0xfd,(uint8_t)0x76,(uint8_t)0xe6,(uint8_t)0x50,(uint8_t)0xd4,(uint8_t)0x53,(uint8_t)0x8e,(uint8_t)0x37,(uint8_t)0x68,(uint8_t)0x30,(uint8_t)0x9,(uint8_t)0x78,(uint8_t)0x6a,(uint8_t)0x13,(uint8_t)0x40,(uint8_t)0xb8,(uint8_t)0x79,(uint8_t)0x5d,(uint8_t)0x60,(uint8_t)0x5e,(uint8_t)0x8c,(uint8_t)0x97,(uint8_t)0xeb,(uint8_t)0xef,(uint8_t)0xf1,(uint8_t)0x78,(uint8_t)0x64,(uint8_t)0x5f,(uint8_t)0xc2,(uint8_t)0x47,(uint8_t)0xb9,(uint8_t)0xc3,(uint8_t)0xb1,(uint8_t)0xa0,(uint8_t)0x6a,(uint8_t)0x7a,(uint8_t)0xe1,(uint8_t)0xe8,(uint8_t)0xc6,(uint8_t)0xc1,(uint8_t)0x65,(uint8_t)0x85,(uint8_t)0xb,(uint8_t)0x2b,(uint8_t)0xcf,(uint8_t)0x5,(uint8_t)0x3e,(uint8_t)0x6c,(uint8_t)0x49,(uint8_t)0xff},
	{(uint8_t)0xae,(uint8_t)0xcd,(uint8_t)0xfa,(uint8_t)0x2c,(uint8_t)0xbc,(uint8_t)0x54,(uint8_t)0xaf,(uint8_t)0x91,(uint8_t)0x13,(uint8_t)0x5,(uint8_t)0xde,(uint8_t)0x71,(uint8_t)0xb9,(uint8_t)0xe1,(uint8_t)0x3d,(uint8_t)0x74,(uint8_t)0xf6,(uint8_t)0xa4,(uint8_t)0x66,(uint8_t)0xd4,(uint8_t)0x51,(uint8_t)0x8e,(uint8_t)0x40,(uint8_t)0x78,(uint8_t)0xef,(uint8_t)0x13,(uint8_t)0x17,(uint8_t)0x9a,(uint8_t)0xdb,(uint8_t)0x5e,(uint8_t)0x72,(uint8_t)0x73,(uint8_t)0xec,(uint8_t)0x7c,(uint8_t)0x50,(uint8_t)0xa3,(uint8_t)0xee,(uint8_t)0xff,(uint8_t)0x8e,(uint8_t)0x7c,(uint8_t)0xd,(uint8_t)0x78,(uint8_t)0xa9,(uint8_t)0x4d,(uint8_t)0x6b,(uint8_t)0xa,(uint8_t)0xaf,(uint8_t)0x75,(uint8_t)0xc5,(uint8_t)0xdb,(uint8_t)0xbd,(uint8_t)0x10,(uint8_t)0xeb,(uint8_t)0x6a,(uint8_t)0x4,(uint8_t)0xcc,(uint8_t)0x45,(uint8_t)0xc4,(uint8_t)0x22,(uint8_t)0xf0,(uint8_t)0xf6,(uint8_t)0x15,(uint8_t)0xc7,(uint8_t)0x55,(uint8_t)0x80,(uint8_t)0xe2,(uint8_t)0x33,(uint8_t)0x44,(uint8_t)0xa9,(uint8_t)0x14,(uint8_t)0x51,(uint8_t)0x94,(uint8_t)0x4a,(uint8_t)0xf9,(uint8_t)0xaa,(uint8_t)0x3a,(uint8_t)0xbb,(uint8_t)0x41,(uint8_t)0x7a,(uint8_t)0x85,(uint8_t)0x5b,(uint8_t)0x66,(uint8_t)0xd1,(uint8_t)0x4d,(uint8_t)0xf8,(uint8_t)0xd4,(uint8_t)0x56,(uint8_t)0x68,(uint8_t)0x42,(uint8_t)0x7e,(uint8_t)0x37,(uint8_t)0x5f,(uint8_t)0xb2,(uint8_t)0xab,(uint8_t)0xed,(uint8_t)0x55,(uint8_t)0x89,(uint8_t)0xad,(uint8_t)0x6c,(uint8_t)0xdb,(uint8_t)0xb9,(uint8_t)0x26,(uint8_t)0x4c,(uint8_t)0x23,(uint8_t)0x99,(uint8_t)0x8e,(uint8_t)0x9c,(uint8_t)0xce,(uint8_t)0xd0,(uint8_t)0xa,(uint8_t)0x34,(uint8_t)0xd,(uint8_t)0x22,(uint8_t)0xc3,(uint8_t)0x83,(uint8_t)0x63,(uint8_t)0xc4,(uint8_t)0x1e,(uint8_t)0x6d,(uint8_t)0x19,(uint8_t)0x12,(uint8_t)0x31,(uint8_t)0xe7,(uint8_t)0x43,(uint8_t)0x89,(uint8_t)0xda,(uint8_t)0x7,(uint8_t)0xae,(uint8_t)0x5b,(uint8_t)0x96,(uint8_t)0x49,(uint8_t)0x8,(uint8_t)0xb,(uint8_t)0x6d,(uint8_t)0x8a,(uint8_t)0x6a,(uint8_t)0x1e,(uint8_t)0xc,(uint8_t)0x77,(uint8_t)0xab,(uint8_t)0x96,(uint8_t)0x3a,(uint8_t)0xfe,(uint8_t)0x27,(uint8_t)0xf6,(uint8_t)0x58,(uint8_t)0x9,(uint8_t)0x13,(uint8_t)0xff,(uint8_t)0xcb,(uint8_t)0x24,(uint8_t)0x7d,(uint8_t)0x71,(uint8_t)0xab,(uint8_t)0xf0,(uint8_t)0x9b,(uint8_t)0xf8,(uint8_t)0x86,(uint8_t)0xa1,(uint8_t)0xfd,(uint8_t)0xfb,(uint8_t)0xd0,(uint8_t)0xbc,(uint8_t)0x2d,(uint8_t)0x32,(uint8_t)0x82,(uint8_t)0xc5,(uint8_t)0xfa,(uint8_t)0xd1,(uint8_t)0xa,(uint8_t)0x96,(uint8_t)0x7,(uint8_t)0x3c,(uint8_t)0xec,(uint8_t)0x4e,(uint8_t)0x27,(uint8_t)0xa8,(uint8_t)0x91,(uint8_t)0x49,(uint8_t)0xb5,(uint8_t)0x3d,(uint8_t)0xda,(uint8_t)0x2a,(uint8_t)0xee,(uint8_t)0x30,(uint8_t)0x7a,(uint8_t)0x1c,(uint8_t)0x47,(uint8_t)0xff,(uint8_t)0x7b,(uint8_t)0xa2,(uint8_t)0x75,(uint8_t)0xa5,(uint8_t)0x4f,(uint8_t)0xa4,(uint8_t)0x1d,(uint8_t)0xe3,(uint8_t)0xb4,(uint8_t)0xe9,(uint8_t)0xdb,(uint8_t)0xfd,(uint8_t)0x2e,(uint8_t)0xf4,(uint8_t)0xb0,(uint8_t)0xb4,(uint8_t)0x85,(uint8_t)0xf1,(uint8_t)0x18,(uint8_t)0x7b,(uint8_t)0xc4,(uint8_t)0x58,(uint8_t)0x59,(uint8_t)0x76,(uint8_t)0x99,(uint8_t)0x93,(uint8_t)0x34,(uint8_t)0xb6,(uint8_t)0x16,(uint8_t)0x67,(uint8_t)0x3a,(uint8_t)0xa4,(uint8_t)0x37,(uint8_t)0xb,(uint8_t)0x65,(uint8_t)0x47,(uint8_t)0xd5,(uint8_t)0xe7,(uint8_t)0x2a,(uint8_t)0x79,(uint8_t)0xe8,(uint8_t)0x82,(uint8_t)0x56,(uint8_t)0xc1,(uint8_t)0xbe,(uint8_t)0x39,(uint8_t)0x98,(uint8_t)0x36,(uint8_t)0xcc,(uint8_t)0x73,(uint8_t)0xd5,(uint8_t)0xaa,(uint8_t)0xf0,(uint8_t)0x54,(uint8_t)0xcf,(uint8_t)0x86,(uint8_t)0x14,(uint8_t)0x65,(uint8_t)0x63,(uint8_t)0x7c,(uint8_t)0x65,(uint8_t)0xd2,(uint8_t)0x83,(uint8_t)0x70,(uint8_t)0xc7,(uint8_t)0xce},
	{(uint8_t)0x3,(uint8_t)0xd8,(uint8_t)0x56,(uint8_t)0x59,(uint8_t)0x72,(uint8_t)0x5,(uint8_t)0xb5,(uint8_t)0x7c,(uint8_t)0x92,(uint8_t)0x88,(uint8_t)0x97,(uint8_t)0xd,(uint8_t)0xbd,(uint8_t)0x8,(uint8_t)0x71,(uint8_t)0x12,(uint8_t)0xe0,(uint8_t)0x47,(uint8_t)0x2f,(uint8_t)0x9b,(uint8_t)0xae,(uint8_t)0x9,(uint8_t)0xd6,(uint8_t)0xf8,(uint8_t)0x90,(uint8_t)0x84,(uint8_t)0x78,(uint8_t)0xae,(uint8_t)0xf0,(uint8_t)0xb4,(uint8_t)0x5b,(uint8_t)0xa9,(uint8_t)0xb1,(uint8_t)0x33,(uint8_t)0x70,(uint8_t)0x95,(uint8_t)0xef,(uint8_t)0xf9,(uint8_t)0xa1,(uint8_t)0xe2,(uint8_t)0xb7,(uint8_t)0x19,(uint8_t)0xa8,(uint8_t)0x5e,(uint8_t)0x88,(uint8_t)0x3c,(uint8_t)0x6d,(uint8_t)0x30,(uint8_t)0xbe,(uint8_t)0x88,(uint8_t)0x2c,(uint8_t)0xf2,(uint8_t)0x11,(uint8_t)0x73,(uint8_t)0x43,(uint8_t)0x8d,(uint8_t)0x13,(uint8_t)0xea,(uint8_t)0xb9,(uint8_t)0xaf,(uint8_t)0x35,(uint8_t)0x2,(uint8_t)0xa6,(uint8_t)0xa8,(uint8_t)0x5a,(uint8_t)0xac,(uint8_t)0x7d,(uint8_t)0x39,(uint8_t)0x38,(uint8_t)0x4a,(uint8_t)0x5f,(uint8_t)0x50,(uint8_t)0xcc,(uint8_t)0x44,(uint8_t)0xd1,(uint8_t)0x71,(uint8_t)0x9b,(uint8_t)0x65,(uint8_t)0x32,(uint8_t)0x0,(uint8_t)0x58,(uint8_t)0x29,(uint8_t)0x26,(uint8_t)0xb5,(uint8_t)0x38,(uint8_t)0x9f,(uint8_t)0x1e,(uint8_t)0x1b,(uint8_t)0xbb,(uint8_t)0xd2,(uint8_t)0xa0,(uint8_t)0x7,(uint8_t)0x55,(uint8_t)0x36,(uint8_t)0xc4,(uint8_t)0xfb,(uint8_t)0xbe,(uint8_t)0x40,(uint8_t)0xad,(uint8_t)0xa8,(uint8_t)0x36,(uint8_t)0x31,(uint8_t)0xdd,(uint8_t)0x99,(uint8_t)0x40,(uint8_t)0xf8,(uint8_t)0xdf,(uint8_t)0x50,(uint8_t)0x3b,(uint8_t)0xd3,(uint8_t)0xe1,(uint8_t)0x87,(uint8_t)0xb8,(uint8_t)0x51,(uint8_t)0xd6,(uint8_t)0xd0,(uint8_t)0x8f,(uint8_t)0xd9,(uint8_t)0x55,(uint8_t)0x30,(uint8_t)0x52,(uint8_t)0x0,(uint8_t)0xd4,(uint8_t)0x27,(uint8_t)0xe8,(uint8_t)0x79,(uint8_t)0x71,(uint8_t)0x77,(uint8_t)0xcf,(uint8_t)0x4c,(uint8_t)0x12,(uint8_t)0x74,(uint8_t)0xf8,(uint8_t)0x50,(uint8_t)0x61,(uint8_t)0x33,(uint8_t)0xd6,(uint8_t)0x64,(uint8_t)0xd8,(uint8_t)0x51,(uint8_t)0x76,(uint8_t)0x8a,(uint8_t)0x2b,(uint8_t)0xe4,(uint8_t)0x5a,(uint8_t)0xa6,(uint8_t)0xb8,(uint8_t)0x8c,(uint8_t)0xe5,(uint8_t)0xa2,(uint8_t)0xf9,(uint8_t)0x27,(uint8_t)0x34,(uint8_t)0xc8,(uint8_t)0xb2,(uint8_t)0x85,(uint8_t)0x8b,(uint8_t)0xc3,(uint8_t)0x6,(uint8_t)0xbf,(uint8_t)0x34,(uint8_t)0x7c,(uint8_t)0xb8,(uint8_t)0x50,(uint8_t)0x2f,(uint8_t)0xf3,(uint8_t)0x76,(uint8_t)0x8b,(uint8_t)0x28,(uint8_t)0x74,(uint8_t)0x34,(uint8_t)0xb2,(uint8_t)0x99,(uint8_t)0xba,(uint8_t)0x5d,(uint8_t)0xbe,(uint8_t)0xaf,(uint8_t)0xe2,(uint8_t)0x49,(uint8_t)0x18,(uint8_t)0xf0,(uint8_t)0x79,(uint8_t)0x20,(uint8_t)0xe1,(uint8_t)0xd5,(uint8_t)0x71,(uint8_t)0x74,(uint8_t)0xf5,(uint8_t)0x60,(uint8_t)0x14,(uint8_t)0xbd,(uint8_t)0x5d,(uint8_t)0xc7,(uint8_t)0x8c,(uint8_t)0x32,(uint8_t)0x21,(uint8_t)0xb1,(uint8_t)0xd9,(uint8_t)0x76,(uint8_t)0xad,(uint8_t)0x1f,(uint8_t)0x8f,(uint8_t)0xa,(uint8_t)0x6,(uint8_t)0xb7,(uint8_t)0x41,(uint8_t)0x3e,(uint8_t)0x74,(uint8_t)0x9a,(uint8_t)0x43,(uint8_t)0xb0,(uint8_t)0x15,(uint8_t)0xc7,(uint8_t)0x33,(uint8_t)0x4b,(uint8_t)0x46,(uint8_t)0x39,(uint8_t)0xe5,(uint8_t)0x64,(uint8_t)0xd,(uint8_t)0x8c,(uint8_t)0xc4,(uint8_t)0x4a,(uint8_t)0x6a,(uint8_t)0x17,(uint8_t)0xe1,(uint8_t)0x4e,(uint8_t)0x78,(uint8_t)0xf9,(uint8_t)0x9e,(uint8_t)0x8,(uint8_t)0x32,(uint8_t)0x7c,(uint8_t)0xb4,(uint8_t)0xd6,(uint8_t)0xd1,(uint8_t)0x29,(uint8_t)0x41,(uint8_t)0xe0,(uint8_t)0xfa,(uint8_t)0xf6,(uint8_t)0xc1,(uint8_t)0x16,(uint8_t)0xf8,(uint8_t)0x66,(uint8_t)0xe4,(uint8_t)0xcb,(uint8_t)0x5e,(uint8_t)0x7a,(uint8_t)0xa9,(uint8_t)0x98,(uint8_t)0x59,(uint8_t)0xb8,(uint8_t)0xdf,(uint8_t)0x2d}
};

int64_t APHash(char* str, uint32_t len)
{
    int64_t hash = 0xAAAAAAAAL;
    uint32_t i = 0;
    
    for(i = 0; i < len; str++, i++)
    {
        hash ^= ((i & 1) == 0) ?
            (  (hash <<  7) ^ (*str) * (hash >> 3)) :
            (~((hash << 11) + ((*str) ^ (hash >> 5))))
        ;
    }
    return hash;
}

int64_t BKDRHash(char* str, uint32_t len)
{
    uint32_t seed = 31;
    int64_t hash = 0;
    uint32_t i    = 0;
    
    for(i = 0; i < len; str++, i++)
    {
        hash = (hash * seed) + (*str);
    }
    return hash;
}

int64_t BPHash(char* str, uint32_t len)
{
    int64_t hash = 0;
    uint32_t i    = 0;
    
    for(i = 0; i < len; str++, i++)
    {
        hash = hash << 7 ^ (*str);
    }
    return hash;
}

int64_t BUZHash(char* str, uint32_t len)
{
    int64_t hash = 0xe12398c6d9ae3b99L;
    uint32_t i = 0;
    
    for(i = 0; i < len; str++, i++)
    {
        hash = (hash << 1) ^ (hash >> 63) ^ BUZtab[(uint8_t)(*str)];
    }
    return hash;
}

int64_t CBUHash(char* str, uint32_t len)
{
    int64_t hash = 0xe12398c6d9ae3b99L;
    uint32_t i = 0;
    
    for(i = 0; i < len; str++, i++)
    {
        hash = (hash << 2) + (*str);
    }
    return hash;
}

int64_t DEKHash(char* str, uint32_t len)
{
    int64_t hash = len;
    int i = 0;
    
    for (i = 0; i < len; str++, i++)
    {
        hash = ((hash << 5) ^ (hash >> 27)) ^ (*str);
    }
    return hash;
}


int64_t DJBHash(char* str, uint32_t len)
{
    int64_t hash = 5381;
    int i = 0;
    
    for (i = 0; i < len; str++, i++)
    {
        hash = ((hash << 5) + hash) + (*str);
    }
    return hash;
}

int64_t ELFHash(char* str, uint32_t len)
{
    int64_t hash = 0;
    int64_t x = 0;
    int64_t i = 0;
    
    for(i = 0; i < len; str++, i++)
    {
        hash = (hash << 4) + (*str);
        if((x = hash & 0xF0000000L) != 0) hash ^= (x >> 24);
        hash &= ~x;
    }
    return hash;
}

int64_t FNVHash(char* str, uint32_t len)
{
    int64_t hash = 0;
    int64_t SEED = 0x811C9DC5L;
    int i = 0;
    
    for (i = 0; i < len; str++,i++)
    {
        hash *= SEED;
        hash ^= (*str);
    }
    return hash;
}

int64_t JSHash(char* str, uint32_t len)
{
    int64_t hash = 1315423911L;
    int i = 0;
    
    for (i = 0; i < len; str++,i++)
    {
        hash ^= ((hash << 5) + (*str) + (hash >> 2));
    }
    return hash;
}

int64_t JavaHash(char* str, uint32_t len)
{
    int64_t hash = 0L;
    int i = 0;
    
    for (i = 0; i < len; str++,i++)
    {
        hash = (hash << 5) - hash + (*str);
    }
    return hash;
}

int64_t PJWHash(char* str, uint32_t len)
{
    const uint32_t BitsInUnsignedInt = (uint32_t)(sizeof(uint32_t) * 8);
    const uint32_t ThreeQuarters = (uint32_t)((BitsInUnsignedInt  * 3) / 4);
    const uint32_t OneEighth = (uint32_t)(BitsInUnsignedInt / 8);
    const uint64_t HighBits = (uint64_t)(0xFFFFFFFF) << (BitsInUnsignedInt - OneEighth);
    int64_t hash = 0;
    int64_t test = 0;
    int i = 0;
    
    for(i = 0; i < len; str++, i++)
    {
        hash = (hash << OneEighth) + (*str);
        if((test = hash & HighBits)  != 0)
        {
            hash = (( hash ^ (test >> ThreeQuarters)) & (~HighBits));
        }
    }
    return hash;
}

int64_t PKPHash(char* str, uint32_t len)
{
    int64_t hash = 0L;
    int i,j = 0;
    int n = 8;
    
    for(i = 0; i < len; str++, i++)
    {
        for(j=0; j<n; j++)
        {
            hash ^= PKPtab[j][(uint8_t)(*str)]<<(j*8);
        }
    }
    return hash;
}

int64_t RSHash(char* str, int32_t len)
{
    int32_t b = 378551;
    int32_t a = 63689;
    int64_t hash = 0;
    int i = 0;
    
    for(i = 0; i < len; str++, i++)
    {
        hash = hash * a + (*str);
        a = a * b;
    }
    return hash;
}

int64_t SDBMHash(char* str, uint32_t len)
{
    int64_t hash = 0;
    int i = 0;
    
    for(i = 0; i < len; str++, i++)
    {
        hash = (*str) + (hash << 6) + (hash << 16) - hash;
    }
    return hash;
}

int64_t JenkinsHash(char *str, uint32_t len)
{
    int64_t hash;
    int i;
    
    for(hash = i = 0; i < len; ++i)
    {
        hash += str[i];
        hash += (hash << 10);
        hash ^= (hash >> 6);
    }
    hash += (hash << 3);
    hash ^= (hash >> 11);
    hash += (hash << 15);
    return hash;
}


int main(int argc, char** argv)
{
    char* k1 = "Hello World!";
    char* k2 = "\xac\xed\x00\x05\x74\x00\x0cHello World!";
    int l1 = 12;
    int l2 = 19;
    int i = 0;
    
    printf("k1: %s; k2: ",k1);
    for (;i<l2;i++)
    {
        if (isprint(k2[i])) printf("%c",k2[i]);
        else printf("\\x%x",(uint8_t)k2[i]);
    }
    printf("\n");
    
    printf("new APHash(), 0x%llxL, 0x%llxL\n",APHash(k1,l1), APHash(k2,l2));
    printf("new BKDRHash(), 0x%llxL, 0x%llxL\n",BKDRHash(k1,l1), BKDRHash(k2,l2));
    printf("new BPHash(), 0x%llxL, 0x%llxL\n",BPHash(k1,l1), BPHash(k2,l2));
    printf("new BUZHash(), 0x%llxL, 0x%llxL\n",BUZHash(k1,l1), BUZHash(k2,l2));
    printf("new CBUHash(), 0x%llxL, 0x%llxL\n",CBUHash(k1,l1), CBUHash(k2,l2));
    printf("new DEKHash(), 0x%llxL, 0x%llxL\n",DEKHash(k1,l1), DEKHash(k2,l2));
    printf("new DJBHash(), 0x%llxL, 0x%llxL\n",DJBHash(k1,l1), DJBHash(k2,l2));
    printf("new ELFHash(), 0x%llxL, 0x%llxL\n",ELFHash(k1,l1), ELFHash(k2,l2));
    printf("new FNVHash(), 0x%llxL, 0x%llxL\n",FNVHash(k1,l1), FNVHash(k2,l2));
    printf("new JSHash(), 0x%llxL, 0x%llxL\n",JSHash(k1,l1), JSHash(k2,l2));
    printf("new JavaHash(), 0x%llxL, 0x%llxL\n",JavaHash(k1,l1), JavaHash(k2,l2));
    printf("new PJWHash(), 0x%llxL, 0x%llxL\n",PJWHash(k1,l1), PJWHash(k2,l2));
    printf("new PKPHash(1,8), 0x%llxL, 0x%llxL\n",PKPHash(k1,l1), PKPHash(k2,l2));
    printf("new RSHash(), 0x%llxL, 0x%llxL\n",RSHash(k1,l1), RSHash(k2,l2));
    printf("new SDBMHash(), 0x%llxL, 0x%llxL\n",SDBMHash(k1,l1), SDBMHash(k2,l2));
    printf("new JenkinsHash(), 0x%llxL, 0x%llxL\n",JenkinsHash(k1,l1), JenkinsHash(k2,l2));
}
